from spb import MB
from spb.series import List2DSeries

from gym_cas import plot_points


def test_plot_points():
    p = plot_points([1, 2, 3, 3], [1, 3, 5, 7], show=False)
    assert isinstance(p, MB)
    s = p.series
    assert len(s) == 1
    assert isinstance(s[0], List2DSeries)
    assert (s[0].get_data()[0] == [1, 2, 3, 3]).all()
    assert (s[0].get_data()[1] == [1, 3, 5, 7]).all()

    p = plot_points([-4, 0], [-2, 5], rendering_kw={"marker": "*"}, show=False)
    assert isinstance(p, MB)
    s = p.series
    assert len(s) == 1
    assert isinstance(s[0], List2DSeries)
    assert (s[0].get_data()[0] == [-4, 0]).all()
    assert (s[0].get_data()[1] == [-2, 5]).all()

    p = plot_points([-4, 0], [-2, 5], rendering_kw={"marker": "*"}, aspect="equal", show=False)
    assert isinstance(p, MB)
    s = p.series
    assert len(s) == 1
    assert isinstance(s[0], List2DSeries)
    assert (s[0].get_data()[0] == [-4, 0]).all()
    assert (s[0].get_data()[1] == [-2, 5]).all()

    a = plot_points(
        [-40, 0, 0],
        [-20, 50, 100],
        "hej",
        annotations=["A", "B", "C"],
        rendering_kw={"marker": "*"},
        aspect="equal",
        show=False,
    )
    b = plot_points(
        [-4, 0], [-2, 5], "hej", rendering_kw={"marker": "*"}, aspect="equal", annotations=["A", "B"], show=False
    )
    assert isinstance(a, MB)
    assert isinstance(b, MB)
    p = a + b
    s = p.series
    assert len(s) == 2
    assert isinstance(s[0], List2DSeries)
    assert s[0].annotations == ["A", "B", "C"]
